"use strict";

Object.defineProperty(exports, "__esModule", {
	value: true
});
exports.default = cleanCssLoader;

var _cleanCss = require("clean-css");

var _cleanCss2 = _interopRequireDefault(_cleanCss);

var _loaderUtils = require("loader-utils");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function cleanCssLoader(css, map) {
	var _this = this;

	var options = this.options ? this.options.module : false;
	var query = (0, _loaderUtils.getOptions)(this);
	var cleanCssOptions = query || (options ? options.cleancss || options["clean-css"] || options.CleanCSS : false) || {};
	var callback = this.async();

	return new _cleanCss2.default(cleanCssOptions).minify(css, map, function (err, minified) {
		if (err) {
			if (Array.isArray(err) && err[0]) {
				return callback(err[0]);
			}
			return callback(err);
		}

		if (!cleanCssOptions.skipWarn && Array.isArray(minified.warnings)) {
			minified.warnings.forEach(function (warning) {
				_this.emitWarning(warning.toString());
			});
		}

		return callback(null, minified.styles, minified.sourceMap);
	});
}
module.exports = exports["default"];